import GLProvider, { Shaders } from "./GLProvider";
import Color from "parsegraph-color";
import Rect from "parsegraph-rect";
import Method from "parsegraph-method";
export default class BasicGLProvider implements GLProvider {
    _shaders: Shaders;
    _gl: WebGLRenderingContext;
    _container: HTMLDivElement;
    _canvas: HTMLCanvasElement;
    _explicitWidth: number;
    _explicitHeight: number;
    _contextChangedListener: Method;
    constructor();
    protected onContextChanged(isLost: boolean): void;
    setOnContextChanged(listener: (isLost: boolean) => void, listenerObj?: any): void;
    shaders(): Shaders;
    hasGL(): boolean;
    protected createGL(): WebGLRenderingContext;
    gl(): WebGLRenderingContext;
    hasCanvas(): boolean;
    protected createCanvas(): HTMLCanvasElement;
    canvas(): HTMLCanvasElement;
    getSize(sizeOut?: Rect): Rect;
    resize(w: number, h: number): void;
    setExplicitSize(w: number, h: number): void;
    getWidth(): number;
    width(): number;
    getHeight(): number;
    height(): number;
    /**
     * @return {HTMLElement} Returns the container that holds the canvas for this graph.
     */
    container(): HTMLElement;
    setBackground(bg: Color): void;
    /**
     * @return {boolean} Returns whether the window has a nonzero client width and height.
     */
    canProject(): boolean;
    /**
     * Renders this provider's content, resizing the canvas to its container.
     *
     * The default implementation only sets the WebGL's clear color to the
     * background but does not clear the canvas.
     *
     * @return {boolean} true if this provider needs an additional call to complete rendering its content.
     * @throws if the scene cannot be projected to, as determined by canProject
     */
    render(): boolean;
}
//# sourceMappingURL=BasicGLProvider.d.ts.map