(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("parsegraph-checkglerror"));
	else if(typeof define === 'function' && define.amd)
		define(["parsegraph-checkglerror"], factory);
	else if(typeof exports === 'object')
		exports["parsegraph_compileprogram"] = factory(require("parsegraph-checkglerror"));
	else
		root["parsegraph_compileprogram"] = factory(root["parsegraph_checkglerror"]);
})(this, (__WEBPACK_EXTERNAL_MODULE_parsegraph_checkglerror__) => {
return /******/ (() => { // webpackBootstrap
/******/ 	var __webpack_modules__ = ({

/***/ "./src/BasicGLProvider.ts":
/*!********************************!*\
  !*** ./src/BasicGLProvider.ts ***!
  \********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var parsegraph_checkglerror__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! parsegraph-checkglerror */ "parsegraph-checkglerror");
/* harmony import */ var parsegraph_checkglerror__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(parsegraph_checkglerror__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var parsegraph_rect__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! parsegraph-rect */ "./node_modules/parsegraph-rect/dist/src/index.js");
/* harmony import */ var parsegraph_rect__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(parsegraph_rect__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var parsegraph_method__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! parsegraph-method */ "./node_modules/parsegraph-method/dist/src/index.js");
/* harmony import */ var parsegraph_method__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(parsegraph_method__WEBPACK_IMPORTED_MODULE_2__);



var BasicGLProvider = /** @class */function () {
  function BasicGLProvider() {
    this._shaders = {};
    this._gl = null;
    this._contextChangedListener = new (parsegraph_method__WEBPACK_IMPORTED_MODULE_2___default())();
    this._container = document.createElement("div");
    this._explicitWidth = null;
    this._explicitHeight = null;
  }
  BasicGLProvider.prototype.onContextChanged = function (isLost) {
    if (isLost) {
      var keys = [];
      for (var k in this._shaders) {
        if (Object.prototype.hasOwnProperty.call(this._shaders, k)) {
          keys.push(k);
        }
      }
      for (var i in keys) {
        if (Object.prototype.hasOwnProperty.call(keys, i)) {
          delete this._shaders[keys[i]];
        }
      }
    }
    this._contextChangedListener.call(isLost);
  };
  BasicGLProvider.prototype.setOnContextChanged = function (listener, listenerObj) {
    this._contextChangedListener.set(listener, listenerObj);
  };
  BasicGLProvider.prototype.shaders = function () {
    return this._shaders;
  };
  BasicGLProvider.prototype.hasGL = function () {
    return !!this._gl;
  };
  BasicGLProvider.prototype.createGL = function () {
    return this.canvas().getContext("webgl");
  };
  BasicGLProvider.prototype.gl = function () {
    if (this.hasGL()) {
      return this._gl;
    }
    this._gl = this.createGL();
    if (this._gl) {
      parsegraph_checkglerror__WEBPACK_IMPORTED_MODULE_0___default()(this._gl, "WebGL creation");
      return this._gl;
    }
    throw new Error("GL context is not supported");
  };
  BasicGLProvider.prototype.hasCanvas = function () {
    return !!this._canvas;
  };
  BasicGLProvider.prototype.createCanvas = function () {
    var _this = this;
    // The 3D canvas that will be drawn to.
    var canvas = document.createElement("canvas");
    canvas.addEventListener("webglcontextlost", function (event) {
      // console.log('Context lost');
      event.preventDefault();
      _this.onContextChanged(true);
    }, false);
    canvas.addEventListener("webglcontextrestored", function () {
      // console.log("Context restored");
      _this.onContextChanged(false);
    }, false);
    canvas.addEventListener("contextmenu", function (e) {
      e.preventDefault();
    }, false);
    canvas.style.display = "block";
    return canvas;
  };
  BasicGLProvider.prototype.canvas = function () {
    if (!this.hasCanvas()) {
      this._canvas = this.createCanvas();
      this.container().appendChild(this._canvas);
    }
    return this._canvas;
  };
  BasicGLProvider.prototype.getSize = function (sizeOut) {
    if (!sizeOut) {
      sizeOut = new (parsegraph_rect__WEBPACK_IMPORTED_MODULE_1___default())();
    }
    sizeOut.setX(0);
    sizeOut.setY(0);
    sizeOut.setWidth(this.width());
    sizeOut.setHeight(this.height());
    return sizeOut;
  };
  BasicGLProvider.prototype.resize = function (w, h) {
    this.container().style.width = typeof w === "number" ? w + "px" : w;
    if (arguments.length === 1) {
      h = w;
    }
    this.container().style.height = typeof h === "number" ? h + "px" : h;
  };
  BasicGLProvider.prototype.setExplicitSize = function (w, h) {
    this._explicitWidth = w;
    this._explicitHeight = h;
    this.resize(w, h);
  };
  BasicGLProvider.prototype.getWidth = function () {
    return this._explicitWidth || this.container().clientWidth;
  };
  BasicGLProvider.prototype.width = function () {
    return this.getWidth();
  };
  BasicGLProvider.prototype.getHeight = function () {
    return this._explicitHeight || this.container().clientHeight;
  };
  BasicGLProvider.prototype.height = function () {
    return this.getHeight();
  };
  /**
   * @return {HTMLElement} Returns the container that holds the canvas for this graph.
   */
  BasicGLProvider.prototype.container = function () {
    return this._container;
  };
  BasicGLProvider.prototype.setBackground = function (bg) {
    this.container().style.backgroundColor = bg.asRGBA();
    if (this.hasGL() && !this.gl().isContextLost()) {
      this.gl().clearColor(bg.r(), bg.g(), bg.b(), bg.a());
    }
  };
  /**
   * @return {boolean} Returns whether the window has a nonzero client width and height.
   */
  BasicGLProvider.prototype.canProject = function () {
    var displayWidth = this.getWidth();
    var displayHeight = this.getHeight();
    return displayWidth != 0 && displayHeight != 0;
  };
  /**
   * Renders this provider's content, resizing the canvas to its container.
   *
   * The default implementation only sets the WebGL's clear color to the
   * background but does not clear the canvas.
   *
   * @return {boolean} true if this provider needs an additional call to complete rendering its content.
   * @throws if the scene cannot be projected to, as determined by canProject
   */
  BasicGLProvider.prototype.render = function () {
    if (this.hasGL() && this.gl().isContextLost()) {
      return true;
    }
    if (!this.canProject()) {
      throw new Error("Refusing to render to an unprojectable window." + " Use canProject() to handle, and parent this" + " window's container to fix.");
    }
    if (this.hasCanvas()) {
      // Lookup the size the browser is displaying the canvas.
      var displayWidth = this.width();
      var displayHeight = this.height();
      // Check if the canvas is not the same size.
      if (this.canvas().width != displayWidth || this.canvas().height != displayHeight) {
        // Make the canvas the same size
        this.canvas().width = displayWidth;
        this.canvas().height = displayHeight;
      }
    }
    return false;
  };
  return BasicGLProvider;
}();
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (BasicGLProvider);

/***/ }),

/***/ "./src/ProxyGLProvider.ts":
/*!********************************!*\
  !*** ./src/ProxyGLProvider.ts ***!
  \********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
var ProxyGLProvider = /** @class */function () {
  function ProxyGLProvider(window) {
    this._glProvider = window;
  }
  ProxyGLProvider.prototype.setOnContextChanged = function (listener, listenerObj) {
    this.glProvider().setOnContextChanged(listener, listenerObj);
  };
  ProxyGLProvider.prototype.glProvider = function () {
    return this._glProvider;
  };
  ProxyGLProvider.prototype.width = function () {
    return this.glProvider().width();
  };
  ProxyGLProvider.prototype.canProject = function () {
    return this.glProvider().canProject();
  };
  ProxyGLProvider.prototype.render = function () {
    return this.glProvider().render();
  };
  ProxyGLProvider.prototype.height = function () {
    return this.glProvider().height();
  };
  ProxyGLProvider.prototype.shaders = function () {
    return this.glProvider().shaders();
  };
  ProxyGLProvider.prototype.container = function () {
    return this.glProvider().container();
  };
  ProxyGLProvider.prototype.hasCanvas = function () {
    return this.glProvider().hasCanvas();
  };
  ProxyGLProvider.prototype.canvas = function () {
    return this.glProvider().canvas();
  };
  ProxyGLProvider.prototype.hasGL = function () {
    return this.glProvider().hasGL();
  };
  ProxyGLProvider.prototype.gl = function () {
    return this.glProvider().gl();
  };
  return ProxyGLProvider;
}();
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (ProxyGLProvider);

/***/ }),

/***/ "./src/WebGL2Provider.ts":
/*!*******************************!*\
  !*** ./src/WebGL2Provider.ts ***!
  \*******************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _BasicGLProvider__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./BasicGLProvider */ "./src/BasicGLProvider.ts");
var __extends = undefined && undefined.__extends || function () {
  var _extendStatics = function extendStatics(d, b) {
    _extendStatics = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (d, b) {
      d.__proto__ = b;
    } || function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    };
    return _extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    _extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
}();

var WebGL2Provider = /** @class */function (_super) {
  __extends(WebGL2Provider, _super);
  function WebGL2Provider() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  WebGL2Provider.prototype.createGL = function () {
    return this.canvas().getContext("webgl2", {
      antialias: true
    });
  };
  return WebGL2Provider;
}(_BasicGLProvider__WEBPACK_IMPORTED_MODULE_0__["default"]);
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (WebGL2Provider);

/***/ }),

/***/ "./src/compileProgram.ts":
/*!*******************************!*\
  !*** ./src/compileProgram.ts ***!
  \*******************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ compileProgram)
/* harmony export */ });
/* harmony import */ var parsegraph_checkglerror__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! parsegraph-checkglerror */ "parsegraph-checkglerror");
/* harmony import */ var parsegraph_checkglerror__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(parsegraph_checkglerror__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var parsegraph_shader__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! parsegraph-shader */ "./node_modules/parsegraph-shader/dist/src/index.js");
/* harmony import */ var parsegraph_shader__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(parsegraph_shader__WEBPACK_IMPORTED_MODULE_1__);


function compileProgram(glProvider, shaderName, vertexShader, fragShader) {
  var gl = glProvider.gl();
  var shaders = glProvider.shaders();
  if (gl.isContextLost()) {
    return;
  }
  if (shaders[shaderName]) {
    return shaders[shaderName];
  }
  var program = gl.createProgram();
  parsegraph_checkglerror__WEBPACK_IMPORTED_MODULE_0___default()(gl, "compileProgram.createProgram(shaderName='", shaderName, ")");
  var compiledVertexShader = (0,parsegraph_shader__WEBPACK_IMPORTED_MODULE_1__.compileShader)(gl, vertexShader, gl.VERTEX_SHADER, shaderName);
  parsegraph_checkglerror__WEBPACK_IMPORTED_MODULE_0___default()(gl, "compileProgram.compile vertex shader(shaderName='", shaderName, ")");
  gl.attachShader(program, compiledVertexShader);
  parsegraph_checkglerror__WEBPACK_IMPORTED_MODULE_0___default()(gl, "compileProgram.attach vertex shader(shaderName='", shaderName, ")");
  var compiledFragmentShader = (0,parsegraph_shader__WEBPACK_IMPORTED_MODULE_1__.compileShader)(gl, fragShader, gl.FRAGMENT_SHADER, shaderName);
  parsegraph_checkglerror__WEBPACK_IMPORTED_MODULE_0___default()(gl, "compileProgram.compile fragment shader(shaderName='", shaderName, ")");
  gl.attachShader(program, compiledFragmentShader);
  parsegraph_checkglerror__WEBPACK_IMPORTED_MODULE_0___default()(gl, "compileProgram.attach fragment shader(shaderName='", shaderName, ")");
  gl.linkProgram(program);
  if (!(0,parsegraph_checkglerror__WEBPACK_IMPORTED_MODULE_0__.ignoreGLErrors)()) {
    var st = gl.getProgramParameter(program, gl.LINK_STATUS);
    if (!st) {
      throw new Error("'" + shaderName + "' shader program failed to link:\n" + gl.getProgramInfoLog(program));
    }
    var err = gl.getError();
    if (err != gl.NO_ERROR && err != gl.CONTEXT_LOST_WEBGL) {
      throw new Error("'" + shaderName + "' shader program failed to link: " + err);
    }
  }
  shaders[shaderName] = program;
  // console.log("Created shader for " + shaderName + ": " + program);
  return program;
}

/***/ }),

/***/ "./node_modules/parsegraph-method/dist/src/index.js":
/*!**********************************************************!*\
  !*** ./node_modules/parsegraph-method/dist/src/index.js ***!
  \**********************************************************/
/***/ (function(module) {

!function(t,e){ true?module.exports=e():0}(this,(function(){return(()=>{"use strict";var t={d:(e,o)=>{for(var n in o)t.o(o,n)&&!t.o(e,n)&&Object.defineProperty(e,n,{enumerable:!0,get:o[n]})},o:(t,e)=>Object.prototype.hasOwnProperty.call(t,e),r:t=>{"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})}},e={};t.r(e),t.d(e,{default:()=>n});var o=function(){function t(t,e){this.set(t,e)}return t.prototype.canCall=function(){return null!=this._func},t.prototype.clear=function(){this.set(null,null)},t.prototype.set=function(t,e){this._func=t,this._funcThisArg=e},t.prototype.call=function(){for(var t=[],e=0;e<arguments.length;e++)t[e]=arguments[e];if(this.canCall())return this._func.apply(this._funcThisArg,t)},t.prototype.apply=function(t){if(this.canCall())return this._func.apply(this._funcThisArg,t)},t}();const n=o;return e})()}));


/***/ }),

/***/ "./node_modules/parsegraph-rect/dist/src/index.js":
/*!********************************************************!*\
  !*** ./node_modules/parsegraph-rect/dist/src/index.js ***!
  \********************************************************/
/***/ (function(module) {

!function(t,i){ true?module.exports=i():0}(this,(function(){return(()=>{"use strict";var t={d:(i,e)=>{for(var h in e)t.o(e,h)&&!t.o(i,h)&&Object.defineProperty(i,h,{enumerable:!0,get:e[h]})},o:(t,i)=>Object.prototype.hasOwnProperty.call(t,i),r:t=>{"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})}},i={};t.r(i),t.d(i,{default:()=>h});var e=function(){function t(t,i,e,h){this._x=t,this._y=i,this._width=e,this._height=h}return t.prototype.isNaN=function(){return isNaN(this._x)||isNaN(this._y)||isNaN(this._width)||isNaN(this._height)},t.prototype.toNaN=function(){this._x=NaN,this._y=NaN,this._width=NaN,this._height=NaN},t.prototype.clear=function(){this.toNaN()},t.prototype.reset=function(){this.toNaN()},t.prototype.x=function(){return this._x},t.prototype.setX=function(t){this._x=t},t.prototype.y=function(){return this._y},t.prototype.setY=function(t){this._y=t},t.prototype.clone=function(i){return i?(this.copy(i),i):new t(this.x(),this.y(),this.width(),this.height())},t.prototype.copy=function(t){return t?(t.setX(this.x()),t.setY(this.y()),t.setWidth(this.width()),t.setHeight(this.height()),t):this.clone()},t.prototype.translate=function(t,i){this.setX(this.x()+t),this.setY(this.y()+i)},t.prototype.scale=function(t,i){arguments.length<2&&(i=t),this.setX(this.x()*t),this.setY(this.y()*i),this.setWidth(this.width()*t),this.setHeight(this.height()*i)},t.prototype.height=function(){return this._height},t.prototype.setHeight=function(t){this._height=t},t.prototype.width=function(){return this._width},t.prototype.w=function(){return this.width()},t.prototype.h=function(){return this.height()},t.prototype.setWidth=function(t){this._width=t},t.prototype.toString=function(){return"[Rect x="+this.x()+", y="+this.y()+", w="+this.width()+", h="+this.height()+"]"},t.prototype.vMin=function(){return this.y()-this.height()/2},t.prototype.vMax=function(){return this.y()+this.height()/2},t.prototype.hMin=function(){return this.x()-this.width()/2},t.prototype.hMax=function(){return this.x()+this.width()/2},t.prototype.include=function(t,i,e,h){if(this.isNaN())return this._x=t,this._y=i,this._width=e,void(this._height=h);var o=this._x,s=this._y,n=this._width,r=this._height,p=Math.min(o-n/2,t-e/2),u=Math.max(o+n/2,t+e/2),y=Math.min(s-r/2,i-h/2),c=u-p,f=Math.max(s+r/2,i+h/2)-y,a=p+c/2,d=y+f/2;this._x=a,this._y=d,this._width=c,this._height=f},t}();const h=e;return i})()}));


/***/ }),

/***/ "./node_modules/parsegraph-shader/dist/src/index.js":
/*!**********************************************************!*\
  !*** ./node_modules/parsegraph-shader/dist/src/index.js ***!
  \**********************************************************/
/***/ (function(module, __unused_webpack_exports, __webpack_require__) {

!function(r,e){ true?module.exports=e(__webpack_require__(/*! parsegraph-checkglerror */ "parsegraph-checkglerror")):0}(this,(function(r){return(()=>{"use strict";var e={561:e=>{e.exports=r}},t={};function o(r){var a=t[r];if(void 0!==a)return a.exports;var n=t[r]={exports:{}};return e[r](n,n.exports,o),n.exports}o.n=r=>{var e=r&&r.__esModule?()=>r.default:()=>r;return o.d(e,{a:e}),e},o.d=(r,e)=>{for(var t in e)o.o(e,t)&&!o.o(r,t)&&Object.defineProperty(r,t,{enumerable:!0,get:e[t]})},o.o=(r,e)=>Object.prototype.hasOwnProperty.call(r,e),o.r=r=>{"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(r,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(r,"__esModule",{value:!0})};var a={};return(()=>{o.r(a),o.d(a,{compileShader:()=>e,createProgram:()=>t,createShaderFromScriptTag:()=>n,createProgramFromScripts:()=>p});var r=o(561);function e(e,t,o,a){var n=e.createShader(o);if(!(e.shaderSource(n,t),e.compileShader(n),(0,r.ignoreGLErrors)()||e.getShaderParameter(n,e.COMPILE_STATUS)))throw new Error("Could not compile "+(o===e.FRAGMENT_SHADER?"fragment":"vertex")+" shader "+a+": "+e.getShaderInfoLog(n));return n}function t(r,e,t){var o=r.createProgram();if(r.attachShader(o,e),r.attachShader(o,t),r.linkProgram(o),!r.getProgramParameter(o,r.LINK_STATUS))throw new Error("program filed to link:"+r.getProgramInfoLog(o));return o}function n(r,t,o){var a=document.getElementById(t);if(!a)throw new Error("*** Error: unknown script element: "+t);var n=a.text;if(!o)if("x-shader/x-vertex"==a.type)o=r.VERTEX_SHADER;else if("x-shader/x-fragment"==a.type)o=r.FRAGMENT_SHADER;else if(!o)throw new Error("*** Error: shader type not set");return e(r,n,o)}function p(r,e,o){return t(r,n(r,e),n(r,o))}})(),a})()}));


/***/ }),

/***/ "parsegraph-checkglerror":
/*!**************************************************************************************************************************************************************!*\
  !*** external {"commonjs":"parsegraph-checkglerror","commonjs2":"parsegraph-checkglerror","amd":"parsegraph-checkglerror","root":"parsegraph_checkglerror"} ***!
  \**************************************************************************************************************************************************************/
/***/ ((module) => {

"use strict";
module.exports = __WEBPACK_EXTERNAL_MODULE_parsegraph_checkglerror__;

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/compat get default export */
/******/ 	(() => {
/******/ 		// getDefaultExport function for compatibility with non-harmony modules
/******/ 		__webpack_require__.n = (module) => {
/******/ 			var getter = module && module.__esModule ?
/******/ 				() => (module['default']) :
/******/ 				() => (module);
/******/ 			__webpack_require__.d(getter, { a: getter });
/******/ 			return getter;
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	(() => {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = (exports) => {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	})();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be in strict mode.
(() => {
"use strict";
/*!**********************!*\
  !*** ./src/index.ts ***!
  \**********************/
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "BasicGLProvider": () => (/* reexport safe */ _BasicGLProvider__WEBPACK_IMPORTED_MODULE_2__["default"]),
/* harmony export */   "ProxyGLProvider": () => (/* reexport safe */ _ProxyGLProvider__WEBPACK_IMPORTED_MODULE_1__["default"]),
/* harmony export */   "WebGL2Provider": () => (/* reexport safe */ _WebGL2Provider__WEBPACK_IMPORTED_MODULE_0__["default"]),
/* harmony export */   "compileProgram": () => (/* reexport safe */ _compileProgram__WEBPACK_IMPORTED_MODULE_3__["default"])
/* harmony export */ });
/* harmony import */ var _WebGL2Provider__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./WebGL2Provider */ "./src/WebGL2Provider.ts");
/* harmony import */ var _ProxyGLProvider__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./ProxyGLProvider */ "./src/ProxyGLProvider.ts");
/* harmony import */ var _BasicGLProvider__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./BasicGLProvider */ "./src/BasicGLProvider.ts");
/* harmony import */ var _compileProgram__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./compileProgram */ "./src/compileProgram.ts");





})();

/******/ 	return __webpack_exports__;
/******/ })()
;
});
//# sourceMappingURL=index.js.map